#ifndef _LINK_HH
#define _LINK_HH

#include <vector>

#include "prologin.hh"

struct LinkGoal {
    unite_energie unit;
    trainee_moto moto;
    position bout;
    std::vector<position> chemin;

    bool ok;
    LinkGoal() : ok(true) { }
};

class Link {
    public:
        Link();
        virtual ~Link();

        /**
         * Definis l'objectif du tour
         */
        void init();

        /**
         * Avance la trainee vers son objectif (1PA)
         * @return true si un deplacement a ete effectue
         */
        bool move();

    protected:
        LinkGoal goal;

        LinkGoal bestGoal();
        bool hasBestGoal;


};

#endif
